#include "Stage.h"
#include "Stages.h"
#include "Main.h"
#include "Vram.h"
#include "VVram.h"
#include "Sprite.h"
#include "Status.h"
#include "CopyMemory.h"
#include "Man.h"
#include "Monster.h"
#include "Destruction.h"

extern void _deb();

ptr<Stage> pStage;
ptr<byte> pStageBytes;
byte[ColumnCount / ColumnsPerByte * FloorCount] CellMap;
// constexpr byte Char_Space = 0;
// constexpr byte Char_LadderLeft = 0x07;
// constexpr byte Char_LadderRight = 0x0d;
// constexpr byte Char_HardFloor = 0x0f;

// static const byte[] UpperChars = {
//     Char_Space, Char_Space, Char_Space, Char_Space, Char_Space, Char_Space,
//     Char_Space, Char_Space, Char_Space, Char_Space, Char_Space, Char_Space,
//     Char_LadderLeft, Char_LadderRight, Char_LadderLeft, Char_LadderRight, Char_LadderLeft, Char_LadderRight, 
//     Char_Space, Char_Space, 0x06, 0x09, 0x09, 0x06,
// };
// static const byte[] LowerChars = {
//     Char_Space, Char_Space, Char_Space, Char_Space, 
//     Char_Space, Char_Space, 0x07, 0x0e,
//     Char_LadderLeft, Char_LadderRight, Char_LadderLeft, Char_LadderRight, 
//     Char_Space, Char_Space, Char_HardFloor, Char_HardFloor,
// };

void InitStage() 
{
    ptr<Stage> p;
    byte i, j;
    p = Stages;
    i = 0;
    j = 0;
    while (i < CurrentStage) {
        ++p;
        ++i;
        ++j;
        if (j >= StageCount) {
            p = Stages;
            j = 0;
        }
    }
    pStage = p;
    pStageBytes = pStage->bytes;
}


// static ptr<byte> DrawCell(ptr<byte> pVVram, byte b, byte y)
// {
//     {
//         ptr<byte> p;
//         byte offset;
//         offset = b & 0xc;
//         offset = (offset >> 1) + offset;
//         p = UpperChars + offset;
//         repeat (3) {
//             if (y < VVramHeight) {
//                 repeat (2) {
//                     *pVVram = *p; ++pVVram;
//                     ++p;
//                 }
//                 pVVram += VVramWidth - 2;
//             }
//             else {
//                 p += 2;
//                 pVVram += VVramWidth;
//             }
//             ++y;
//         }
//     }
//     pVVram -= VVramWidth;
//     --y;
//     {
//         ptr<byte> p;
//         byte offset;
//         offset = b & 0x3;
//         offset <<= 2; 
//         p = LowerChars + offset;
//         {
//             if (y < VVramHeight) {
//                 repeat (2) {
//                     byte c;
//                     c = *p; ++p;
//                     if (c != Char_Space) {
//                         *pVVram = c; ++pVVram;
//                     }
//                     else {
//                         ++pVVram;
//                     }
//                 }
//                 pVVram += VVramWidth - 2;
//             }
//             else {
//                 p += 2;
//                 pVVram += VVramWidth;
//             }
//             ++y;
//         }
//         {
//             if (y < VVramHeight) {
//                 repeat (2) {
//                     byte c;
//                     c = *p; ++p;
//                     *pVVram = c; ++pVVram;
//                 }
//                 pVVram += -VVramWidth * (FloorHeight - 1);
//             }
//             else {
//                 p += 2;
//                 pVVram += -VVramWidth * (FloorHeight - 1) + 2;
//             }
//             ++y;
//         }
//     }
//     return pVVram;
// }

void InitTrying()
{
    {
        byte i;
        StageTime = 25;
        i = pStage->itemCount;
        do {
            StageTime += 5;
            --i;
        } while (i != 0);
    }
    ItemCount = pStage->itemCount;
    HideAllSprites();
    ClearScreen();
    PrintStatus();

    CopyMemory(CellMap, pStageBytes, ColumnCount / ColumnsPerByte * FloorCount);
    InitMan();
    InitMonsters();
    InitDestructions();
    // UpdateSprites();
    DrawAll();
}


byte GetCell(byte column, byte floor)
{
    byte b;
    b = *CellMapPtr(column, floor);
    if ((column & 1) == 0) {
        return b & 0x0f;
    }
    else {
        return b >> 4;
    }
}


void SetCell(byte column, byte floor, byte cell)
{
    ptr<byte> pCell;
    byte mask;
    pCell = CellMapPtr(column, floor);
    if ((column & 1) == 0) {
        mask = 0xf0;
        cell &= 0x0f;
    }
    else {
        mask = 0x0f;
        cell <<= 4;
    }
    *pCell = (*pCell & mask) | cell;
}