include "ZeroPage.inc"
include "VVram.inc"

ext VVram_
ext CellMap_

ColumnCount equ 12
FloorCount equ 4
ColumnsPerByte equ 2
FloorHeight equ 4
ColumnWidth equ 2

Cell_Space equ 0
Cell_LowerMask equ 3
Cell_CrackedFloor equ 1
Cell_HardFloor equ 3
Cell_LadderDown equ 2
Cell_UpperMask equ 0ch
Cell_BrokenFloor equ 4
Cell_LadderUp equ 8
Cell_Item equ 0ch

Char_Space equ 0
Char_ItemLT equ $06
Char_ItemRT equ $09
Char_ItemLB equ $09
Char_ItemRB equ $06
Char_HoleL equ $01
Char_HoleR equ $00
Char_HardFloor equ $0f
Char_LadderL equ $07
Char_LadderR equ $0d
Char_CrackL equ $07
Char_CrackR equ $0e

pVVram equ ZW0
pMap equ ZW1
pair equ ZW2
mapByte equ ZB0

; ptr<byte> CellMapPtr(byte column, byte floor);
dseg
CellMapPtr_@Param1: public CellMapPtr_@Param1
    defb 0
cseg
CellMapPtr_: public CellMapPtr_
    psha
        lsra
        staa <pVVram+1
        ldaa CellMapPtr_@Param1
        asla ;*2
        adda CellMapPtr_@Param1 ;*3
        asla ;*6
        adda <pVVram+1
        adda #low CellMap_
        staa <pVVram+1
        ldaa #0
        adca #high CellMap_
        staa <pVVram
        ldx <pVVram
    pula
rts


; void MapToVVram();
MapToVVram_Row:
    stx <pair
    ldx <pVVram
    ldaa <pair | staa 0,x
    ldaa <pair+1 | staa 1,x
    xgdx | addd #VVramWidth | xgdx
    stx <pVVram
    ldx <pair
rts
MapToVVram_Rows:
    do
        bsr MapToVVram_Row
        decb
    while ne | wend
rts
MapToVVram_: public MapToVVram_
    psha | pshb
        ldx #VVram_ | stx <pVVram
        ldx #CellMap_ | stx <pMap
        ldab #FloorCount
        do
            pshb
                ldab #ColumnCount/ColumnsPerByte
                do
                    pshb
                        ldx <pMap | ldaa 0,x | inx | stx <pMap
                        staa <mapByte
                        ldab #ColumnsPerByte
                        do
                            pshb
                                ldaa <mapByte
                                anda #Cell_UpperMask
                                cmpa #Cell_BrokenFloor
                                if eq
                                    ldx #Char_Space shl 8 or Char_Space
                                    ldab #3
                                    bsr MapToVVram_Rows
                                    ldx #Char_HoleL shl 8 or Char_HoleR
                                    bsr MapToVVram_Row
                                    bra nextColumn
                                endif
                                cmpa #Cell_Item
                                if eq
                                    ldx #Char_Space shl 8 or Char_Space
                                    bsr MapToVVram_Row
                                    ldx #Char_ItemLT shl 8 or Char_ItemRT
                                    bsr MapToVVram_Row
                                    ldx #Char_ItemLB shl 8 or Char_ItemRB
                                    bsr MapToVVram_Row
                                    ldx #Char_HardFloor shl 8 or Char_HardFloor
                                    bsr MapToVVram_Row
                                    bra nextColumn
                                endif
                                cmpa #Cell_LadderUp
                                if eq
                                    ldx #Char_LadderL shl 8 or Char_LadderR
                                    ldab #3
                                    bsr MapToVVram_Rows
                                    ldaa <mapByte
                                    anda #Cell_LowerMask
                                    cmpa #Cell_LadderDown
                                    if ne
                                        ldx #Char_HardFloor shl 8 or Char_HardFloor
                                    endif
                                    bsr MapToVVram_Row
                                    jmp nextColumn
                                endif
                                ldx #Char_Space shl 8 or Char_Space
                                ldab #2
                                bsr MapToVVram_Rows
                                
                                ldaa <mapByte
                                anda #Cell_LowerMask
                                cmpa #Cell_LadderDown
                                if eq
                                    ldx #Char_LadderL shl 8 or Char_LadderR
                                    ldab #2
                                    bsr MapToVVram_Rows
                                    jmp nextColumn
                                endif
                                ldx #Char_Space shl 8 or Char_Space
                                bsr MapToVVram_Row

                                ldaa <mapByte
                                anda #Cell_LowerMask
                                cmpa #Cell_CrackedFloor
                                if eq
                                    ldx #Char_CrackL shl 8 or Char_CrackR
                                else
                                    cmpa #Cell_HardFloor
                                    if eq
                                        ldx #Char_HardFloor shl 8 or Char_HardFloor
                                    endif
                                endif
                                bsr MapToVVram_Row

                                nextColumn:
                                ldd <pVVram | addd #-VVramWidth*FloorHeight+ColumnWidth | std <pVVram
                            pulb
                            ldaa <mapByte
                            lsra | lsra | lsra | lsra
                            staa <mapByte
                            decb
                        while ne | wend
                    pulb
                    decb
                while ne | wend
                ldd <pVVram | addd #VVramWidth*FloorHeight-ColumnCount*ColumnWidth | std <pVVram
            pulb
            decb
        while ne | wend
    pulb | pula
rts
