include "ZeroPage.inc"
include "Vram.inc"
include "VVram.inc"

ext VVram_

WRTP26 equ $FED4
LCDMOD equ $FF55

pVram equ ZW0
pPattern equ ZW1
leftByte equ ZB0
rightByte equ ZB1
maskByte equ ZB2

xCount equ ZB3
yCount equ ZB4
pVVram equ ZW0
pBackup equ ZW1

dseg
Vram_: public Vram_
    defs VramRowSize*VramHeight
Backup:
    defs VVramWidth*VVramHeight


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    psha | pshb
        ldx #Vram_
        do
            clr 0,x | inx
            cpx #Vram_+VramRowSize*VramHeight
        while ne | wend
        
        ldx #Backup
        ldd #VVramWidth*VVramHeight
        do
            clr 0,x | inx
            subd #1
        while ne | wend
    pulb | pula
jmp PresendVram_


; void PresendVram();
cseg
WriteLcd:
    orab #$08
    ldaa #$0f
    jsr WRTP26

    ldaa #$64 | jsr LCDMOD
    tba | anda #$40 | oraa #$80 | jsr LCDMOD

    ldd #$0800 | jsr WRTP26
    ldab #40
    do
        ldaa 0,x | inx
        jsr LCDMOD
        decb
    while ne | wend
rts
PresendVram_: public PresendVram_
    psha | pshb
        ldx #Vram_
        ldab #$01 | bsr WriteLcd
        ldab #$02 | bsr WriteLcd
        ldab #$03 | bsr WriteLcd
        ldab #$01 or $40 | bsr WriteLcd
        ldab #$02 or $40| bsr WriteLcd
        ldab #$03 or $40| bsr WriteLcd
        ldab #$04 | bsr WriteLcd
        ldab #$05 | bsr WriteLcd
        ldab #$06 | bsr WriteLcd
        ldab #$04 or $40 | bsr WriteLcd
        ldab #$05 or $40| bsr WriteLcd
        ldab #$06 or $40| bsr WriteLcd
    pulb | pula
rts


; ptr<byte> PrintC(ptr<byte> address, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_pVram:
    defw 0
PrintC_@Param1: public PrintC_@Param1
PrintC_c: 
    defb 0
cseg
CharTable:
    defb " 0123456789ACEFGHIKMNOPRSTUVY"
PrintC_: public PrintC_
    psha | pshb
        ldx PrintC_pVram | stx <pVram

        ldaa PrintC_c
        clrb
        ldx #CharTable
        do
            cmpa 0,x
            beq PrintC_break
            incb
            inx
            cpx #CharTable+29
        while ne | wend
        clrb
        PrintC_break:
        aslb | aslb
        ldx #AsciiPattern
        abx | stx <pPattern
        ldab #CharWidth
        do
            ldx <pPattern
            ldaa 0,x | inx
            stx <pPattern
            ldx <pVram
            staa 0,x | inx
            stx <pVram
            decb
        while ne | wend
    pulb | pula
    ldx <pVram
rts


; ptr<byte> Put(ptr<byte> pVram, byte c, byte shift);
cseg
dseg
Put_@Param0: public Put_@Param0
Put_pVram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
    defb 0
Put_@Param2: public Put_@Param2
Put_shift:
    defb 0
cseg
Put_: public Put_
    psha | pshb
        ldaa Put_c
        tab
        anda #$03 | staa <leftByte
        lsrb | lsrb | stab <rightByte
        ldaa #$fc | staa<maskByte

        ldab Put_shift
        if ne
            do
                sec | rol <maskByte
                asl <leftByte
                asl <rightByte
                decb
            while ne | wend
        endif
        
        ldx Put_pVram
        ldaa 0,x
        anda <maskByte
        oraa <leftByte
        staa 0,x | inx
        ldaa 0,x
        anda <maskByte
        oraa <rightByte
        staa 0,x | inx
    pulb | pula
rts


; void VVramToVram();
VVramToVram_: public VVramToVram_
    psha | pshb
        ldx #Vram_ | stx Put_pVram
        ldx #VVram_ | stx <pVVram
        ldx #Backup | stx <pBackup
        clr Put_shift
        ldaa #VVramHeight | staa <yCount
        do
            ldaa #VVramWidth | staa <xCount
            do
                ldx <pVVram
                ldaa 0,x | inx
                stx <pVVram
                ldx <pBackup
                cmpa 0,x
                if ne
                    staa Put_c
                    staa 0,x | inx
                    stx <pBackup
                    bsr Put_
                    stx Put_pVram
                else
                    inx
                    stx <pBackup
                    ldx Put_pVram
                    inx | inx
                    stx Put_pVram
                endif
                dec <xCount
            while ne | wend              
            ldx Put_pVram
            xgdx
                subd #VVramWidth*2
            xgdx

                                    _deb: public _deb
            ldaa Put_shift
            adda #2
            anda #7
            if eq
                xgdx
                    addd #VramRowSize
                xgdx
            endif
            staa Put_shift  

            stx Put_pVram
            dec <yCount
        while ne | wend
    pulb | pula
rts

cseg
AsciiPattern: public AsciiPattern
	; ascii 29
	; " 0123456789ACEFGHIKMNOPRSTUVY"
	defb 00h,00h,00h,00h,1fh,11h,1fh,00h
	defb 00h,00h,1fh,00h,1dh,15h,17h,00h
	defb 15h,15h,1fh,00h,07h,04h,1fh,00h
	defb 17h,15h,1dh,00h,1fh,15h,1dh,00h
	defb 01h,1dh,03h,00h,1fh,15h,1fh,00h
	defb 17h,15h,1fh,00h,1eh,09h,1eh,00h
	defb 0eh,11h,0ah,00h,1fh,15h,11h,00h
	defb 1fh,05h,01h,00h,0eh,11h,0dh,00h
	defb 1fh,04h,1fh,00h,11h,1fh,11h,00h
	defb 1fh,04h,1bh,00h,1fh,06h,1fh,00h
	defb 1fh,01h,1eh,00h,0eh,11h,0eh,00h
	defb 1fh,05h,07h,00h,1fh,05h,1ah,00h
	defb 16h,15h,0dh,00h,01h,1fh,01h,00h
	defb 1fh,10h,1fh,00h,0fh,10h,0fh,00h
	defb 03h,1ch,03h,00h
